// This file is generated by kconfig_compiler from sflphone-client-kde.kcfg.
// All changes you do to this file will be lost.
#ifndef CONFIGURATIONSKELETONBASE_H
#define CONFIGURATIONSKELETONBASE_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class ConfigurationSkeletonBase : public KConfigSkeleton
{
  public:
    class EnumInterface
    {
      public:
      enum type { ALSA, PulseAudio, COUNT };
    };

    static ConfigurationSkeletonBase *self();
    ~ConfigurationSkeletonBase();

    /**
      Set Defines the port that will be used for SIP communication.
    */
    static
    void setSIPPort( int v )
    {
      if (v <  1025 )
      {
        kDebug() << "setSIPPort: value " << v << " is less than the minimum value of  1025 ";
        v =  1025 ;
      }

      if (v >  65536 )
      {
        kDebug() << "setSIPPort: value " << v << " is greater than the maximum value of  65536 ";
        v =  65536 ;
      }

      if (!self()->isImmutable( QString::fromLatin1( "SIPPort" ) ))
        self()->mSIPPort = v;
    }

    /**
      Get Defines the port that will be used for SIP communication.
    */
    static
    int sIPPort()
    {
      return self()->mSIPPort;
    }

    /**
      Set Defines whether sflphone should keep a history of calls.
    */
    static
    void setEnableHistory( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "enableHistory" ) ))
        self()->mEnableHistory = v;
    }

    /**
      Get Defines whether sflphone should keep a history of calls.
    */
    static
    bool enableHistory()
    {
      return self()->mEnableHistory;
    }

    /**
      Set Defines the number of days the history has to be kept.
    */
    static
    void setHistoryMax( int v )
    {
      if (v <  1 )
      {
        kDebug() << "setHistoryMax: value " << v << " is less than the minimum value of  1 ";
        v =  1 ;
      }

      if (v >  99 )
      {
        kDebug() << "setHistoryMax: value " << v << " is greater than the maximum value of  99 ";
        v =  99 ;
      }

      if (!self()->isImmutable( QString::fromLatin1( "historyMax" ) ))
        self()->mHistoryMax = v;
    }

    /**
      Get Defines the number of days the history has to be kept.
    */
    static
    int historyMax()
    {
      return self()->mHistoryMax;
    }

    /**
      Set Defines whether user should be notified when receiving a call.
    */
    static
    void setNotifOnCalls( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "notifOnCalls" ) ))
        self()->mNotifOnCalls = v;
    }

    /**
      Get Defines whether user should be notified when receiving a call.
    */
    static
    bool notifOnCalls()
    {
      return self()->mNotifOnCalls;
    }

    /**
      Set Defines whether user should be notified when receiving a message.
    */
    static
    void setNotifOnMessages( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "notifOnMessages" ) ))
        self()->mNotifOnMessages = v;
    }

    /**
      Get Defines whether user should be notified when receiving a message.
    */
    static
    bool notifOnMessages()
    {
      return self()->mNotifOnMessages;
    }

    /**
      Set Defines whether the main window should be displayed on start.
    */
    static
    void setDisplayOnStart( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayOnStart" ) ))
        self()->mDisplayOnStart = v;
    }

    /**
      Get Defines whether the main window should be displayed on start.
    */
    static
    bool displayOnStart()
    {
      return self()->mDisplayOnStart;
    }

    /**
      Set Defines whether the main window should be displayed when receiving a message.
    */
    static
    void setDisplayOnCalls( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayOnCalls" ) ))
        self()->mDisplayOnCalls = v;
    }

    /**
      Get Defines whether the main window should be displayed when receiving a message.
    */
    static
    bool displayOnCalls()
    {
      return self()->mDisplayOnCalls;
    }

    /**
      Set Defines whether the dialpad is being shown by default
    */
    static
    void setDisplayDialpad( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayDialpad" ) ))
        self()->mDisplayDialpad = v;
    }

    /**
      Get Defines whether the dialpad is being shown by default
    */
    static
    bool displayDialpad()
    {
      return self()->mDisplayDialpad;
    }

    /**
      Set Defines whether the volume widgets are visible by default
    */
    static
    void setDisplayVolume( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayVolume" ) ))
        self()->mDisplayVolume = v;
    }

    /**
      Get Defines whether the volume widgets are visible by default
    */
    static
    bool displayVolume()
    {
      return self()->mDisplayVolume;
    }

    /**
      Set Defines whether the main menu is visible by default, it can be restored with "Ctrl+m"
    */
    static
    void setDisplayMenu( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayMenu" ) ))
        self()->mDisplayMenu = v;
    }

    /**
      Get Defines whether the main menu is visible by default, it can be restored with "Ctrl+m"
    */
    static
    bool displayMenu()
    {
      return self()->mDisplayMenu;
    }

    /**
      Set Defines whether call history is restricted to a specific date range
    */
    static
    void setDisplayDataRange( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayDataRange" ) ))
        self()->mDisplayDataRange = v;
    }

    /**
      Get Defines whether call history is restricted to a specific date range
    */
    static
    bool displayDataRange()
    {
      return self()->mDisplayDataRange;
    }

    /**
      Set Defines if the individual contact history list is visible
    */
    static
    void setDisplayContactCallHistory( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayContactCallHistory" ) ))
        self()->mDisplayContactCallHistory = v;
    }

    /**
      Get Defines if the individual contact history list is visible
    */
    static
    bool displayContactCallHistory()
    {
      return self()->mDisplayContactCallHistory;
    }

    /**
      Set Defines the Stun server to use.
    */
    static
    void setInterface( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "interface" ) ))
        self()->mInterface = v;
    }

    /**
      Get Defines the Stun server to use.
    */
    static
    int interface()
    {
      return self()->mInterface;
    }

    /**
      Set Defines whether ringtones are enabled.
    */
    static
    void setEnableRingtones( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "enableRingtones" ) ))
        self()->mEnableRingtones = v;
    }

    /**
      Get Defines whether ringtones are enabled.
    */
    static
    bool enableRingtones()
    {
      return self()->mEnableRingtones;
    }

    /**
      Set Defines which ringtone is used.
    */
    static
    void setRingtone( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ringtone" ) ))
        self()->mRingtone = v;
    }

    /**
      Get Defines which ringtone is used.
    */
    static
    QString ringtone()
    {
      return self()->mRingtone;
    }

    /**
      Set Defines which ALSA plugin to use.
    */
    static
    void setAlsaPlugin( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "alsaPlugin" ) ))
        self()->mAlsaPlugin = v;
    }

    /**
      Get Defines which ALSA plugin to use.
    */
    static
    QString alsaPlugin()
    {
      return self()->mAlsaPlugin;
    }

    /**
      Set Defines which ALSA Input device to use.
    */
    static
    void setAlsaInputDevice( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "alsaInputDevice" ) ))
        self()->mAlsaInputDevice = v;
    }

    /**
      Get Defines which ALSA Input device to use.
    */
    static
    int alsaInputDevice()
    {
      return self()->mAlsaInputDevice;
    }

    /**
      Set Defines which ALSA Output device to use.
    */
    static
    void setAlsaOutputDevice( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "alsaOutputDevice" ) ))
        self()->mAlsaOutputDevice = v;
    }

    /**
      Get Defines which ALSA Output device to use.
    */
    static
    int alsaOutputDevice()
    {
      return self()->mAlsaOutputDevice;
    }

    /**
      Set Defines whether pulse audio can mute other applications during a call.
    */
    static
    void setPulseAudioVolumeAlter( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "pulseAudioVolumeAlter" ) ))
        self()->mPulseAudioVolumeAlter = v;
    }

    /**
      Get Defines whether pulse audio can mute other applications during a call.
    */
    static
    bool pulseAudioVolumeAlter()
    {
      return self()->mPulseAudioVolumeAlter;
    }

    /**
      Set Defines whether the search in KDE Address Book is enabled
    */
    static
    void setEnableAddressBook( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "enableAddressBook" ) ))
        self()->mEnableAddressBook = v;
    }

    /**
      Get Defines whether the search in KDE Address Book is enabled
    */
    static
    bool enableAddressBook()
    {
      return self()->mEnableAddressBook;
    }

    /**
      Set Defines the max number of contacts to display during a search in address book.
    */
    static
    void setMaxResults( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "maxResults" ) ))
        self()->mMaxResults = v;
    }

    /**
      Get Defines the max number of contacts to display during a search in address book.
    */
    static
    int maxResults()
    {
      return self()->mMaxResults;
    }

    /**
      Set Defines whether to display contacts photos.
    */
    static
    void setDisplayPhoto( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "displayPhoto" ) ))
        self()->mDisplayPhoto = v;
    }

    /**
      Get Defines whether to display contacts photos.
    */
    static
    bool displayPhoto()
    {
      return self()->mDisplayPhoto;
    }

    /**
      Set Defines whether to display professionnal phone numbers.
    */
    static
    void setBusiness( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "business" ) ))
        self()->mBusiness = v;
    }

    /**
      Get Defines whether to display professionnal phone numbers.
    */
    static
    bool business()
    {
      return self()->mBusiness;
    }

    /**
      Set Defines whether to display mobile phone numbers.
    */
    static
    void setMobile( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "mobile" ) ))
        self()->mMobile = v;
    }

    /**
      Get Defines whether to display mobile phone numbers.
    */
    static
    bool mobile()
    {
      return self()->mMobile;
    }

    /**
      Set Defines whether to display personnal phone numbers.
    */
    static
    void setHome( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "home" ) ))
        self()->mHome = v;
    }

    /**
      Get Defines whether to display personnal phone numbers.
    */
    static
    bool home()
    {
      return self()->mHome;
    }

    /**
      Set List of bookmarked clients
    */
    static
    void setBookmarkList( const QStringList & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "bookmarkList" ) ))
        self()->mBookmarkList = v;
    }

    /**
      Get List of bookmarked clients
    */
    static
    QStringList bookmarkList()
    {
      return self()->mBookmarkList;
    }

    /**
      Set Defines the destination directory for call recordings.
    */
    static
    void setDestinationFolder( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "destinationFolder" ) ))
        self()->mDestinationFolder = v;
    }

    /**
      Get Defines the destination directory for call recordings.
    */
    static
    QString destinationFolder()
    {
      return self()->mDestinationFolder;
    }

    /**
      Set Defines whether to enable hooks for SIP accounts.
    */
    static
    void setEnableHooksSIP( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "enableHooksSIP" ) ))
        self()->mEnableHooksSIP = v;
    }

    /**
      Get Defines whether to enable hooks for SIP accounts.
    */
    static
    bool enableHooksSIP()
    {
      return self()->mEnableHooksSIP;
    }

    /**
      Set Defines whether to enable hooks for IAX accounts.
    */
    static
    void setEnableHooksIAX( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "enableHooksIAX" ) ))
        self()->mEnableHooksIAX = v;
    }

    /**
      Get Defines whether to enable hooks for IAX accounts.
    */
    static
    bool enableHooksIAX()
    {
      return self()->mEnableHooksIAX;
    }

    /**
      Set Defines which header to catch for SIP accounts hooks.
    */
    static
    void setHooksSIPHeader( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "hooksSIPHeader" ) ))
        self()->mHooksSIPHeader = v;
    }

    /**
      Get Defines which header to catch for SIP accounts hooks.
    */
    static
    QString hooksSIPHeader()
    {
      return self()->mHooksSIPHeader;
    }

    /**
      Set Defines which command to execute.
    */
    static
    void setHooksCommand( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "hooksCommand" ) ))
        self()->mHooksCommand = v;
    }

    /**
      Get Defines which command to execute.
    */
    static
    QString hooksCommand()
    {
      return self()->mHooksCommand;
    }

    /**
      Set Defines whether to add a prefix for outgoing calls.
    */
    static
    void setAddPrefix( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "addPrefix" ) ))
        self()->mAddPrefix = v;
    }

    /**
      Get Defines whether to add a prefix for outgoing calls.
    */
    static
    bool addPrefix()
    {
      return self()->mAddPrefix;
    }

    /**
      Set Defines the prefix to add.
    */
    static
    void setPrepend( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "prepend" ) ))
        self()->mPrepend = v;
    }

    /**
      Get Defines the prefix to add.
    */
    static
    QString prepend()
    {
      return self()->mPrepend;
    }

  protected:
    ConfigurationSkeletonBase();
    friend class ConfigurationSkeletonBaseHelper;


    // main
    int mSIPPort;
    bool mEnableHistory;
    int mHistoryMax;
    bool mNotifOnCalls;
    bool mNotifOnMessages;
    bool mDisplayOnStart;
    bool mDisplayOnCalls;
    bool mDisplayDialpad;
    bool mDisplayVolume;
    bool mDisplayMenu;
    bool mDisplayDataRange;
    bool mDisplayContactCallHistory;
    int mInterface;
    bool mEnableRingtones;
    QString mRingtone;
    QString mAlsaPlugin;
    int mAlsaInputDevice;
    int mAlsaOutputDevice;
    bool mPulseAudioVolumeAlter;
    bool mEnableAddressBook;
    int mMaxResults;
    bool mDisplayPhoto;
    bool mBusiness;
    bool mMobile;
    bool mHome;
    QStringList mBookmarkList;
    QString mDestinationFolder;
    bool mEnableHooksSIP;
    bool mEnableHooksIAX;
    QString mHooksSIPHeader;
    QString mHooksCommand;
    bool mAddPrefix;
    QString mPrepend;

  private:
};

#endif

